summaryrefslogtreecommitdiff
path: root/tests/cp
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2009-07-27 17:08:02 +0200
committerJim Meyering <meyering@redhat.com>2009-08-04 17:38:54 +0200
commiteae535e1a322e244248bd31ed7e21ac95ecaa16d (patch)
treeecc8956558befd65ef146eb233d46e16dba7c735 /tests/cp
parent1762092901adf040445d59931d14837ef7f2ebe1 (diff)
downloadcoreutils-eae535e1a322e244248bd31ed7e21ac95ecaa16d.tar.xz
cp -pP (and e.g., -a): preserve time stamps on symlinks, too
* src/copy.c (utimensat_if_possible): New function. (copy_internal): Remove variable, "preserve_metadata". Replace with "dest_is_symlink". That covers all cases but one: the one in which cp --link has created hard links to non-directories. In that case, there is no need to update attributes of the links. Use utimensat_if_possible, to preserve timestamps of symlinks. * NEWS (New features): Mention this. * tests/Makefile.am (TESTS): Add cp/preserve-slink-time. * tests/cp/preserve-slink-time: New file. * m4/jm-macros.m4 (coreutils_MACROS): Test for utimensat. Reported in http://bugzilla.redhat.com/230866
Diffstat (limited to 'tests/cp')
-rwxr-xr-xtests/cp/preserve-slink-time44
1 files changed, 44 insertions, 0 deletions
diff --git a/tests/cp/preserve-slink-time b/tests/cp/preserve-slink-time
new file mode 100755
index 000000000..c5c21a5e1
--- /dev/null
+++ b/tests/cp/preserve-slink-time
@@ -0,0 +1,44 @@
+#!/bin/sh
+# Verify that cp -Pp preserves times even on symlinks.
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cp --version
+fi
+
+. $srcdir/test-lib.sh
+
+grep '^#define HAVE_UTIMENSAT' "$CONFIG_HEADER" > /dev/null ||
+ skip_test_ 'this system lacks the utimensat function'
+
+ln -s no-such dangle || framework_failure
+
+# If the current file system lacks sub-second resolution, sleep for 2s to
+# ensure that the times on the copy are different from those of the original.
+case $(stat --format=%y dangle) in
+ ??:??:??.000000000) sleep 2;;
+esac
+
+cp -Pp dangle d2 || framework_failure
+stat --format=%y dangle > t1 || framework_failure
+stat --format=%y d2 > t2 || framework_failure
+
+fail=0
+compare t1 t2 || fail=1
+
+Exit $fail